=== starch/Makefile ===
all: mypy

mypy:
	MYPYPATH=$(CURDIR)/stubs mypy --show-error-codes starch.py
