=== debian/changelog ===
dump1090-fa (10.2) stable; urgency=medium

  * No change release for 10.2

 -- Nicholas Wan <nicholas.wan@flightaware.com>  Wed, 28 May 2025 12:48:45 -0500

dump1090-fa (10.1) stable; urgency=medium

  * SkyAware: Update aircraft DB to 2025-05-14
  * SkyAware: Update file name versioning to enable cache busting

 -- Eric Tran <eric.tran@flightaware.com>  Wed, 14 May 2025 21:58:00 -0600

dump1090-fa (10.0.1) stable; urgency=medium

  * No change release for 10.0.1

 -- Nicholas Wan <nicholas.wan@flightaware.com>  Mon, 24 Mar 2025 10:56:18 -0500

dump1090-fa (10.0) stable; urgency=medium

  * Pass options to all SDR drivers for handling
  * soapysdr: --enable-agc doesn't take an option value, don't require one
  * Change calloc parameter order to fix build issues with newer gcc (courtesy @Swiftyhu, PR #239)
  * Add missing build package to README (courtesy @lstolcman, #234)
  * SkyAware: Replaces broken ChartBundle IFR and VFR layers with argGIS maps
  * SkyAware: Mobile display improvements (courtesy @gregdev, PR #235)

 -- Nicholas Wan <nicholas.wan@flightaware.com>  Wed, 26 Feb 2025 16:16:10 +0000

dump1090-fa (9.1~dev) UNRELEASED; urgency=medium

  * in development

 -- Oliver Jowett <oliver.jowett@flightaware.com>  Fri, 10 Nov 2023 18:04:49 +0800

dump1090-fa (9.0) stable; urgency=medium

  * dump1090: SoapySDR support (courtesy @bkoehm, PR #209)
  * dump1090: fix handling of negative FMS altitudes in DO-260A messages
  * dump1090: update aircraft DB to 2023-10-26
  * packaging: add bookworm, arm64 support
  * packaging: discontinue stretch support
  * tools: update tools/csv-to-json.py for Python 3

 -- Oliver Jowett <oliver.jowett@flightaware.com>  Mon, 06 Nov 2023 21:34:26 +0800

dump1090-fa (8.2) stable; urgency=medium

  * No change release for 8.1

 -- Eric Tran <eric.tran@flightaware.com>  Tue, 13 Dec 2022 20:06:00 -0600

dump1090-fa (8.1) stable; urgency=medium

  * No change release for 8.1

 -- Eric Tran <eric.tran@flightaware.com>  Wed, 07 Dec 2022 19:26:00 -0600

dump1090-fa (8.0) stable; urgency=medium

  * dump1090: fix dropped samples stats accounting (#178 / #184)
  * dump1090: help text updates (#199, #145)
  * dump1090: warn about unimplemented --no-crc-check option if given (#201)
  * dump1090: implement 'l'/'L' Beast option to request local-only data (#204)
  * dump1090: emit receiver gain setting even when adaptive gain is off (#203)
  * dump1090: correctly handle gain stats on SDRs that don't implement the gain interface (#206)
  * SkyAware: remove a stray query string
  * SkyAware: improve visibility of range rings and altitude chart on the darker map layers
  * SkyAware: add colors to heywhatsthat.com rings (#148)
  * SkyAware: add favicon.ico (#101)
  * SkyAware: update Swiss flag (#175)
  * SkyAware: update aircraft DB to 2022-09-28

 -- Eric Tran <eric.tran@flightaware.com>  Tue, 06 Dec 2022 12:48:29 -0600

dump1090-fa (7.2) stable; urgency=medium

  * dump1090: Fix Makefile syntax error for Darwin OS build (courtesy @CodyCodeman, PR #170)
  * dump1090: set _POSIX_C_SOURCE to fix build failure with uclibc-ng (courtesy @ffontaine, PR #169)
  * SkyAware: Remove obselete map interface at /dump1090-fa
  * SkyAware: Remove OSM Black & White layer which is no longer in service

 -- Eric Tran <eric.tran@flightaware.com>  Wed, 09 Mar 2022 20:09:55 -0600

dump1090-fa (7.1) stable; urgency=medium

  * Preserve start/upgrade postinst logic for pre 7.1 updates until we support compat 10 behavior

 -- Eric Tran <eric.tran@flightaware.com>  Wed, 12 Jan 2022 11:37:20 -0600

dump1090-fa (7.0) stable; urgency=medium

  * dump1090: Allow env vars (not only command line overrdies) to set CPU_FEATURES_{ARCH,UNAME}
  * dump1090: Treat ARCH=arm64 like ARCH=aarch64
  * dump1090: Try to respect CFLAGS/CPPFLAGS as far as possible; move required extra flags into a separate var
  * dump1090: Adaptive gain - more aggressively re-probe for higher gain after a decrease in gain due to increased noise floor
  * dump1090: Cleanup AVR parsing
  * SkyAware: Update aircraft db to 20211210
  * SkyAware: Cleanup unused Openlayers files

 -- Eric Tran <eric.tran@flightaware.com>  Mon, 20 Dec 2021 11:00:00 -0600

dump1090-fa (6.1) stable; urgency=medium

  * No-change 6.1 release for PiAware 6.1

 -- Oliver Jowett <oliver.jowett@flightaware.com>  Mon, 06 Sep 2021 16:06:00 +0800

dump1090-fa (6.0) stable; urgency=medium

  * dump1090: Adaptive gain feature with associated dump1090-fa config parameters
  * dump1090: Add support for decoding BDS 4,4 - Meteorological Routine Air Report (MRAR) Comm-B messages
  * dump1090: Stratux output: include current receiver gain (courtesy @b3nn0, PR #144)
  * dump1090: Enable rtlsdr bounce buffers on aarch64 (courtesy @wiedehopf for suggestion)
  * dump1090: New default dump1090-fa config file format
  * dump1090: Use compat/compat.h for endian-swapping functions in DSP code
  * dump1090: Report json write errors, with some rate limiting (fixes issue #129)
  * starch: Update starch to upstream commit 0c8249fa4bc523345c156885542e9192e8bf68fd
  * SkyAware: restrict overlay rendering to covered areas (reduce source load) (courtesy @wiedehopf, PR #137)
  * SkyAware: Fix ignored DisplayUnits in config.js (courtesy @paulyc, PR #76)
  * SkyAware: Update aircraft db to 20210817 with better Australian aircraft & types

 -- Eric Tran <eric.tran@flightaware.com>  Tue, 31 Aug 2021 12:41:06 -0600

dump1090-fa (5.0) stable; urgency=medium

  * SkyAware: New Altitude, Speed, Aircraft Ident, and Aircraft Type filters to fine tune the select aircraft you want see
  * SkyAware: Ability to toggle visibility of ADS-B, MLAT, UAT, TIS-B, and Other aircraft on SkyAware using the check boxes under the aircraft table
  * SkyAware: Ability to show Aircraft Ident labels for all aircraft on your display (found in the View Toggles list in the settings menu)
  * SkyAware: A merged SkyAware map of 1090 and UAT aircraft for those with dual 1090/978 setups.

